
/*
***	Copyright:	1994-1996 Gnter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/


#ifndef MAX_BTN_STATES
#define	MAX_BTN_STATES	4				// max. number of states for buttons; 2^n;	typical value: 4
#endif


typedef struct btn btn;
struct btn
{	btn*	prev;					// for linked list
	btn*	next;					// for linked list
	Rect	bbox;					// position and size of button; will be scaled if required
	short	btn[MAX_BTN_STATES];	// CIcons of buttons: MX states: dimmed/state 1 ... MX-1; only used states must be set
	short	pbtn[MAX_BTN_STATES];	// CIcons of pressed buttons: dito
	short	icn[MAX_BTN_STATES];	// CIcons of symbols: dito; auto-centered (shifted x+1, y+1 if pressed)
	char	nxt_sta[MAX_BTN_STATES];// state -> next state, if button is pressed
	char	state;					// actually selected state for this button plus visible-flag
	short	id;						// unique identifier for this button
};


extern				Draw_Button		(btn *btn, Boolean pressed);	// draw button except if 'invisible'
extern				Set_Button		(btn *btn, short new_state);	// change state & draw released version
extern	Boolean		Handle_Button	(btn *btn);						// handle mouse tracking after click in button
extern	btn*		Find_Button		(btn *btn, Point p);			// find button where mouse clicked in, if any

extern	CIconHandle	Get_CIcon		( short n );
extern				Read_CIcons		();


extern void Link (btn* a, btn* b);
