
/*	Menu handler

***	Copyright:	1994-1996 Gnter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

	05.Feb.1995:	Extracted this file from application.c
*/


#include	"kio.h"
#include	"menue.h"
#include	"application.h"
#include	"messages.h"
#include	"z80.h"
#include	"preferences.h"
#include	"z80.options"
#include	"sound.h"

MenuHandle	profilemenu		= nil;
MenuHandle	debugmenu		= nil;
MenuHandle 	applemenu			= nil;
MenuHandle	filemenu			= nil;
MenuHandle	editmenu			= nil;
MenuHandle	optionsmenu		= nil;
MenuHandle	logmenu			= nil;
MenuHandle	windowsmenu		= nil;
MenuHandle	speedmenu		= nil;
MenuHandle	soundmenu		= nil;

// -----	Rename all menu entries according to new_language ------------------------------
MenuBarNewLanguage(short new_language)
{	
	language = new_language;
	
	SetItem 	( applemenu, iAbout, 		localized("\pAbout Mac Spectacle ","\pber Mac Spectacle " ));
	SetItem	( applemenu, iHelp,			localized("\pKeyboard","\pTastatur" ));
	
	SetItem	( filemenu, iOpen,			localized("\pOpen ","\pffnen " ));
	SetItem	( filemenu, iSave,			localized("\pSave ","\pSpeichern " ));
	SetItem	( filemenu, iCloseTopWindow,	localized("\pClose","\pSchlieen" ));
	SetItem	( filemenu, iNew,			localized("\pNew","\pNeustart" ));
	SetItem	( filemenu, iSuspend,			localized("\pHold CPU","\pCPU anhalten" ));
	SetItem	( filemenu, iResume,			localized("\pResume CPU","\pCPU freigeben" ));
	SetItem	( filemenu, iPreferences,		localized("\pSave Preferences","\pVoreinstellungen speichern" ));
	SetItem	( filemenu, iQuit,			localized("\pQuit","\pBeenden" ));

	SetItem	( editmenu, 1,				localized("\pNot supported","\pNicht untersttzt" ));  

	SetItem	( optionsmenu, iInternational,	localized("\pInternational (Englisch)","\pInternational (British)" ));
	SetItem	( optionsmenu, iGerman,		localized("\pDeutsch (German)","\pDeutsch (German)" ));
	SetItem 	( optionsmenu, i48k,			"\pZX Spectrum 48k");
	SetItem 	( optionsmenu, i128,			"\pZX Spectrum 128");
	SetItem 	( optionsmenu, iplus2,		"\pZX Spectrum +2");
	SetItem 	( optionsmenu, iNormalSize,	localized("\pDisplay 1:1","\pBildgre 1:1" ));
	SetItem 	( optionsmenu, iDoubleSize,	localized("\pDisplay 2:1","\pBildgre 2:1" ));
	SetItem 	( optionsmenu, iTripleSize,	localized("\pDisplay 3:1","\pBildgre 3:1" ));
	SetItem 	( optionsmenu, iQuadSize,		localized("\pDisplay 4:1","\pBildgre 4:1" ));
	SetItem 	( optionsmenu, iBasicKeys,	localized("\pBasic Keyboard","\pTastatur fr Basic" ));
	SetItem	( optionsmenu, iGameKeys,	localized("\pGame Keyboard","\pTastatur fr Spiele" ));
	SetItem 	( optionsmenu, iMultitasking,	localized("\pMultitasking enabled","\pMultitasking zulassen" ));
	SetItem 	( optionsmenu, iAvoidOffscreen,localized("\pWrite directly to screen","\pDirekt in den Bildschirm schreiben" ));
	SetItem 	( optionsmenu, iForceOffscreen,localized("\pUse Offscreen Buffer","\pBildschirm gepuffert vorzeichnen" ));
	SetItem	( optionsmenu, iLogToCon,		localized("\pMessages to console","\pMeldungen zur Konsole" ));
	SetItem	( optionsmenu, iLogToFile,		localized("\pMessages to logfile","\pMeldungen in's Logbuch" ));
	SetItem	( optionsmenu, iQuiet,		localized("\pOnly alerts","\pNur Alarmmeldungen" ));
	SetItem	( optionsmenu, iVerbose,		localized("\pVerbose messages","\pNormale Meldungen" ));
	SetItem	( optionsmenu, iEverything,	localized("\pDebugger messages too","\pAuch Debuggermeldungen" ));
	SetItem	( optionsmenu, iOpenDebugger,	localized("\pExpert menues","\pExpertenmens" ));

	SetItem	( speedmenu, iUnlimitedSpeed,	localized("\pUnlimited speed","\pUngebremst" ));
	SetItem	( speedmenu, iExactSpeed,	localized("\pExact timing","\pExaktes Timing" ));
	SetItem	( speedmenu, iHighresMode,	localized("\pHighres mode","\pHighres-Modus" ));
	SetItem	( speedmenu, iBetter,		localized("\p68k assember Z80 engine","\pZ80-Emulation in 68k-Assembler" ));
	SetItem	( speedmenu, iBest,			localized("\pC-based Z80 engine","\pZ80-Emulation in C" ));
	SetItem	( speedmenu, iLessVideoAdjust,	localized("\pHires effects up","\pHires-Effekte hher" ));
	SetItem	( speedmenu, iMoreVideoAdjust,localized("\pHires effects down","\pHires-Effekte tiefer" ));

	SetItem	( debugmenu, iSuspOnIllegals,	localized("\pSuspend on illegals","\pStop bei illegalen Befehlen" ));
	SetItem	( debugmenu, iSuspOnWeird,	localized("\pSuspend on weird illegals","\pStop bei seltsamen Befehlen" ));
	SetItem	( debugmenu, iTriggerIrpt,	localized("\pTrigger interrupt","\pInterrupt auslsen" ));
	SetItem	( debugmenu, iTriggerNMI,	localized("\pTrigger NMI","\pNMI auslsen" ));
	SetItem	( debugmenu, iTriggerReset,	localized("\pTrigger reset","\pReset auslsen" ));
	SetItem	( debugmenu, iWritableROM,	localized("\pROM writable","\pROM berschreibbar" ));
	SetItem	( debugmenu, iTest,			localized("\pTest","\pTest" ));

	SetItem	( logmenu, iLogIrpt,			localized("\pLog interrupts",			"\pLog Interrupts" ));
	SetItem	( logmenu, iLogNMI,			localized("\pLog NMI",				"\pLog NMI" ));
	SetItem	( logmenu, iLogIllegals,		localized("\pLog illegal instructions",	"\pLog illegale Befehle" ));
	SetItem	( logmenu, iLogWeird,		localized("\pLog weird illegals",		"\pLog seltsame Befehle" ));
	SetItem	( logmenu, iLogAllLegals,		localized("\pLog all legal instructions",	"\pLog alle normalen Befehle" ));
	SetItem	( logmenu, iLogNoLegals,		localized("\pDon't log legal instructions",	"\pLog keine normalen Befehle" ));
	SetItem	( logmenu, iLogEI,			"\pLog EI" );
	SetItem	( logmenu, iLogDI,			"\pLog DI" );
	SetItem	( logmenu, iLogIM0,			"\pLog IM 0" );
	SetItem	( logmenu, iLogIM1,			"\pLog IM 1" );
	SetItem	( logmenu, iLogIM2,			"\pLog IM 2" );
	SetItem	( logmenu, iLogRETI,			"\pLog RETI" );
	SetItem	( logmenu, iLogRETN,			"\pLog RETN" );
	SetItem	( logmenu, iLogHALT,		"\pLog HALT" );
	SetItem	( logmenu, iLogDAA,			"\pLog DAA" );
	SetItem	( logmenu, iLogR,			"\pLog LD A,R  & LD R,A" );
	SetItem	( logmenu, iLogI,			"\pLog LD A,I  &  LD I,A" );
	SetItem	( logmenu, iLogRST0,		"\pLog RST 0" );
	SetItem	( logmenu, iLogRST1,		"\pLog RST 8" );
	SetItem	( logmenu, iLogRST2,		"\pLog RST 16" );
	SetItem	( logmenu, iLogRST3,		"\pLog RST 24" );
	SetItem	( logmenu, iLogRST4,		"\pLog RST 32" );
	SetItem	( logmenu, iLogRST5,		"\pLog RST 40" );
	SetItem	( logmenu, iLogRST6,		"\pLog RST 48" );
	SetItem	( logmenu, iLogRST7,		"\pLog RST 56" );

	SetItem	( profilemenu, iClearInstrProf,	localized("\pClear instruction profile",	"\pBefehlsprofil lschen" ));
	SetItem	( profilemenu, iCountInstr,	localized("\pCount instructions",		"\pBefehle zhlen" ));
	SetItem	( profilemenu, iLogFirstInstr,	localized("\pLog first use",			"\pLog erste Verwendung" ));
	SetItem	( profilemenu, iShowInstrProf,	localized("\pShow profile",			"\pProfil anzeigen (kurz)" ));
	SetItem	( profilemenu, iShowInstrXProf,localized("\pShow verbose profile",		"\pProfil anzeigen (lang)" ));
	SetItem	( profilemenu, iClearLocProf,	localized("\pClear location profile",		"\pAdressprofil lschen" ));
	SetItem	( profilemenu, iCountLoc,		localized("\pCount locations",			"\pAdressen zhlen" ));
	SetItem	( profilemenu, iLogFirstLoc,	localized("\pLog first execution",		"\pLog erste Ausfhrung" ));
	SetItem	( profilemenu, iShowLocProf,	localized("\pShow profile",			"\pProfil anzeigen (kurz)" ));
	SetItem	( profilemenu, iShowLocXProf,	localized("\pShow verbose profile",		"\pProfil anzeigen (lang)" ));

	SetItem	( windowsmenu, iConsole,			localized("\pConsole", 			"\pKonsole" ));
	SetItem	( windowsmenu, iSpectrum,		localized("\pZX Spectrum",		"\pZX Spectrum" ));
	SetItem	( windowsmenu, iTape,			localized("\pTape recorder", 		"\pKassettenrekorder" ));
	SetItem	( windowsmenu, iMovie,			localized("\pMovie recorder", 		"\pVideorekorder" ));
	SetItem	( windowsmenu, iKeyboard,		localized("\pKeyboard",			"\pTastatur" ));
	SetItem	( windowsmenu, iAboutWindow, 	localized("\pAbout Mac Spectacle",	"\pber Mac Spectacle" ));
	SetItem	( windowsmenu, iCloseTopWindow,	localized("\pClose top window",	"\pOberstes Fenster schlieen" ));

	SetItem	( soundmenu, i22,			"\p22 kHz" );
	SetItem	( soundmenu, i44,			"\p44 kHz" );

	SetItem	( soundmenu, iAY,			localized("\pAY-3-8912 emulation","\pAY-3-8912 Emulation") );
	SetItem	( soundmenu, iAY_A,			localized("\pChannel A","\pTonkanal A") );
	SetItem	( soundmenu, iAY_B,			localized("\pChannel B","\pTonkanal B") );
	SetItem	( soundmenu, iAY_C,			localized("\pChannel C","\pTonkanal C") );

	SetItem	( soundmenu, iSoundOff,		localized("\pOff","\pAus" ));
	SetItem	( soundmenu, iSoundOff+1,	"\p1" );
	SetItem	( soundmenu, iSoundOff+2,	"\p2" );
	SetItem	( soundmenu, iSoundOff+3,	"\p3" );
	SetItem	( soundmenu, iSoundOff+4,	"\p4" );
	SetItem	( soundmenu, iSoundOff+5,	"\p5" );
	SetItem	( soundmenu, iSoundOff+6,	"\p6" );
	SetItem	( soundmenu, iMaxVolume,	localized("\pMax","\pMax" ));
}


AddDebuggerMenus()
{	InsertMenu ( debugmenu, mWindows );
	InsertMenu ( logmenu, mWindows );
	InsertMenu ( profilemenu, mWindows );
	DrawMenuBar();
}

RemoveDebuggerMenus()
{	DeleteMenu(mDebug);
	DeleteMenu(mLogging);
	DeleteMenu(mProfile);
	DrawMenuBar();
}


InitMenuBar ()		// most items are renamed by MenuBarNewLanguage()
{	
	applemenu 	= NewMenu ( mApple,	"\p\024" );	InsertMenu ( applemenu, 0 );
	filemenu 		= NewMenu ( mFile,		"\pFile" );	InsertMenu ( filemenu, 0 );
	editmenu 		= NewMenu ( 140, 		"\pEdit" );	InsertMenu ( editmenu, 0 );
	optionsmenu	= NewMenu ( mOptions,	"\pOptions" );	InsertMenu ( optionsmenu, 0 );
	speedmenu	= NewMenu ( mSpeed,	"\pSpeed" );	InsertMenu ( speedmenu, 0 );
	soundmenu	= NewMenu ( mSound,	"\pSound" );	InsertMenu ( soundmenu, 0 );
	windowsmenu	= NewMenu ( mWindows,	"\pWindows" );	InsertMenu ( windowsmenu, 0 );
	debugmenu	= NewMenu ( mDebug,	"\pDebug" );	
	logmenu		= NewMenu ( mLogging,	"\pLog" );	
	profilemenu	= NewMenu ( mProfile,	"\pProfiles" );	
	
	AppendMenu 	( applemenu, "\pAbout/\035" );		SetItemIcon ( applemenu,iAbout,300);
	AppendMenu	( applemenu, "\pKeyboard/\035" );		SetItemIcon ( applemenu,iHelp,301);
	AddResMenu	( applemenu, 'DRVR' );
	
	AppendMenu 	( filemenu, "\pOpen/O;Save/S;Close/W;---" );
	AppendMenu	( filemenu, "\pNew/N;Hold/H;Resume/R;---" );
	AppendMenu	( filemenu, "\pPrefs;---;Quit/Q" );

	AppendMenu	( editmenu, "\p---" );

	AppendMenu	( debugmenu, "\pSuspI;SuspW;---;nmi;irpt;res;---;rwRom;test" );

	AppendMenu	( logmenu, "\pirpt;nmi;---;ill;weird;---;all;none;---" );
	AppendMenu	( logmenu, "\pei;di;0;1;2;reti;retn;halt;daa;r;i;0;1;2;3;4;5;6;7" );

	AppendMenu	( profilemenu, "\pclr;cnt;log;show;verb;---;clr;cnt;log;show;verb" );
	
	
	AppendMenu	( optionsmenu, "\pEng/\035" );	SetItemIcon(optionsmenu,iInternational,305);
	AppendMenu	( optionsmenu, "\pGer/\035" );	SetItemIcon(optionsmenu,iGerman,306);
	AppendMenu	( optionsmenu, "\p---;48k;128;+2" );
	AppendMenu	( optionsmenu, "\p---;1:1/1;2:1/2;3:1/3;4:1/4" );
	AppendMenu	( optionsmenu, "\p---;basic kbd/B;game kbd/G" );
	AppendMenu	( optionsmenu, "\p---;Multitasking/M;offscreen;direct" );
	AppendMenu	( optionsmenu, "\p---;con;file;---;quiet;verbose;all;---;debug" );

	AppendMenu	( soundmenu, "\p22;44;---;AY;A;B;C;---;0;1;2;3;4;5;6;7");

	AppendMenu	( speedmenu, "\pUnlimited/U;Exact/X;Highres/Y;---" );
	AppendMenu	( speedmenu, "\pBetter/A;Best/C;---" );
	AppendMenu	( speedmenu, "\pLessAdj/-;MoreAdj/+" );

	AppendMenu	( windowsmenu, "\pCon/\035;Specci/\035;Tape/\035;Movie/\035;Kbd/\035;About/\035" );
	SetItemIcon	( windowsmenu, iConsole,304);
	SetItemIcon	( windowsmenu, iSpectrum,302);
	SetItemIcon	( windowsmenu, iTape,303);
	SetItemIcon	( windowsmenu, iMovie,307);
	SetItemIcon	( windowsmenu, iKeyboard,301);
	SetItemIcon	( windowsmenu, iAboutWindow,300);
#if !include_movie
	DisableItem(windowsmenu,iMovie);
#endif

	DisableItem ( editmenu, 0 );
	
#if GENERATINGPOWERPC
	DisableItem ( speedmenu, iBetter );
#endif

#if !CMD_PROFILE
	DisableItem ( profilemenu, iClearInstrProf );
	DisableItem ( profilemenu, iCountInstr );
	DisableItem ( profilemenu, iLogFirstInstr );
	DisableItem ( profilemenu, iShowInstrProf );
	DisableItem ( profilemenu, iShowInstrXProf );
#endif

#if !PC_PROFILE
	DisableItem ( profilemenu, iClearLocProf );
	DisableItem ( profilemenu, iCountLoc );
	DisableItem ( profilemenu, iLogFirstLoc );
	DisableItem ( profilemenu, iShowLocProf );
	DisableItem ( profilemenu, iShowLocXProf );
#endif

#if !INFO_ILLEGALS
	DisableItem ( logmenu, iLogIllegals );
	DisableItem ( debugmenu, iSuspOnIllegals );
#endif

#if !INFO_WEIRD
	DisableItem ( logmenu, iLogWeird );
	DisableItem ( debugmenu, iSuspOnWeird );
#endif

#if !INFO_IRPT
	DisableItem ( logmenu, iLogIrpt );
#endif

#if !INFO_NMI
	DisableItem ( logmenu, iLogNMI );
#endif

#if !INFO_MISC
	{	int i;
		DisableItem ( logmenu, iLogAllLegals );
		DisableItem ( logmenu, iLogNoLegals );
		for (i=iLogEI; i<=iLogRST7; i++) DisableItem ( logmenu, i );
	}
#endif

	DrawMenuBar();
}







