
/*
***	Copyright:	1994-1996 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

    20.Oct.01   revised for CW7Pro and ANSI C compliance									hdusel@bnv-gz.de
*/

extern	MenuHandle 	
		profilemenu,	applemenu,	filemenu, 		editmenu, 
		logmenu,		optionsmenu,	debugmenu,	windowsmenu,	
		speedmenu,	soundmenu,	volumemenu;


extern	void MenuBarNewLanguage(short new_language);
extern	void InitMenuBar 		(void);
extern	void AddDebuggerMenus();
extern	void RemoveDebuggerMenus();


// ----- Menu Bar -------------------------------------------------

#define	mApple		  128		
#define	iAbout			1		
#define	iHelp			2

#define	mFile		129			
#define		iOpen			1		// Load CORE
#define		iSave			2		// Save CORE
#define		iCloseTopWindow	3		// close top window
#define		iNew				5		// Restart
#define 		iSuspend			6		// Suspend
#define		iResume			7		// Resume
#define		iPreferences		9
#define		iQuit				11

#define	mOptions	133
#define		iInternational		1
#define		iGerman			2
#define		i48k				4
#define		i128				5
#define		iplus2			6
#define		iNormalSize		8
#define		iDoubleSize		9
#define		iTripleSize		10
#define		iQuadSize			11
#define		iBasicKeys		13
#define		iGameKeys		14
#define		iMultitasking		16
#define		iForceOffscreen	17
#define		iAvoidOffscreen	18
#define		iLogToCon			20
#define		iLogToFile			21
#define		iLogOnlyCon		22	// no real menu entry -> used by preferences only!
#define		iQuiet			23
#define		iVerbose			24
#define		iEverything		25
#define		iOpenDebugger		27

#define	mSpeed	134
#define		iUnlimitedSpeed		1
#define		iExactSpeed		2
#define		iHighresMode		3
#define		iBetter			5
#define		iBest				6
#define		iLessVideoAdjust	8
#define		iMoreVideoAdjust	9

#define	mSound	135				// Sound settings
#define		i22				1	// 22 kHz sampling frequency
#define		i44				2	// 44 kHz sampling frequency
#define		iAY				4	// AY emulation on/off
#define		iAY_A			5	// channel A
#define		iAY_B			6	// ... B
#define		iAY_C			7	// ... C
#define		iSoundOff			9	// volume 0
#define		iDefaultVolume		13	// ...
#define		iMaxVolume		16	// volume max

#define	mDebug		130
#define		iSuspOnIllegals		1
#define		iSuspOnWeird		2
#define		iTriggerNMI		4
#define		iTriggerIrpt		5
#define		iTriggerReset		6
#define		iWritableROM		8
//#define		iTraceMode		8
#define		iTest				9

#define	mLogging		131
#define		iLogIrpt			1
#define		iLogNMI			2
//			---				3
#define		iLogIllegals		4
#define		iLogWeird			5
//			---				6
#define		iLogAllLegals		7
#define		iLogNoLegals		8
//			---				9
#define		iLogEI			10
#define		iLogDI			11
#define		iLogIM0			12
#define		iLogIM1			13
#define		iLogIM2			14
#define		iLogRETI			15
#define		iLogRETN			16
#define		iLogHALT			17
#define		iLogDAA			18
#define		iLogR			19
#define		iLogI				20
#define		iLogRST0			21
#define		iLogRST1			22
#define		iLogRST2			23
#define		iLogRST3			24
#define		iLogRST4			25
#define		iLogRST5			26
#define		iLogRST6			27
#define		iLogRST7			28

#define	mProfile		132
#define		iClearInstrProf		1
#define		iCountInstr		2
#define		iLogFirstInstr		3
#define		iShowInstrProf		4
#define		iShowInstrXProf	5
#define		iClearLocProf		7
#define		iCountLoc			8
#define		iLogFirstLoc		9
#define		iShowLocProf		10
#define		iShowLocXProf		11

#define	mWindows		199
#define		iConsole			1
#define		iSpectrum			2
#define		iTape			3
#define		iMovie			4
#define		iKeyboard			5
#define		iAboutWindow		6





