/*	KIO's standard options file

***	Copyright:	1996-1999 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.


	***	Mac Spectacle ***
*/

#ifndef		options_h
#define		options_h options_h


// -----	system wide safety tests enabling/disabling -------------------------------------
//#define	SAFE	0	// 0 = final version:		TRAP(), OMEM() and IERR()
				// 1 = development stage:	dito + XTRAP()		check of parameters
				// 2 = debugging:		dito + XXTRAP()		check of results

// -----	system wide logging level --------------------------------------------------
//#define	LOG	0	// 0 = final version:		LogXYZ()			errors
				// 1 = development stage:	dito + vLogXYZ()	initialization, statistics
				// 2 = debugging:		dito + vvLogXYZ()	procedure entry, test points, variable values



#define		include_movie		0


#define		include_debugger	0


// localization
#define		localized(A,B)		(language==iInternational?(A):(B))


// preferences.c
#define		APPLID			'ZXSP'			// application's signature
#define		PREFNAME			"\pkio's prefs"		// stick to this file
#define		PREFGAP			1000			// default gap for preferences array
#define		SCRAMBLE			0x123cdea3		// application's scramble base


// pollevents.c
#define		SCROLLBARS		1			// automatic handling of window scrollbars and grow box?
#define		USE_OWN_DRAG		1			// use application's own HadleDRAG() routine


// terminal.c
#define		TERMNAME		"\pMac Spectacle"
#define		MAXLINES			30
#define		MAXCOLUMNS		80
#define		BORDER			4
#define		TABS			8
#define		FONTNAME		"\pMonaco"
#define		CHARHEIGHT		9


// checkgestalt.c
#if !COMPILINGPOWERPC
#define		min_cpu			gestalt68020
#define		req_fpu			0
#endif
#define		min_QD			gestalt32BitQD


// buttons.c
#define		MAX_BTN_STATES	4			// max. number of states for buttons; 2^n;	typical value: 4

#define		MAX_CIC			128			// size of cicn array
#define		MIN_CIC_ID		128			// minimum cicn number to look for
#define		MAX_CIC_ID		600			// maximum cicn number to look for (excl.)




#endif

















