/*
***	Copyright:	1994-1999 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

    20.Oct.01   revised for CW7Pro and ANSI C compliance									hdusel@bnv-gz.de
*/

extern	void	PlaySample		( void );
extern	void	SuspendSound	( void );
extern	void	ResumeSound		( void );


extern	long	GetSampleRate		( void );
extern	void	SetSampleRate		( long n );
#define	sample_rate_44	0xac440000
#define	sample_rate_22	0x56EE8BA3


extern	void	SetSoundVolume	( short n );
extern	short	GetSoundVolume	( void );
extern	short	sound_volume;		// 0 == sound off

extern	void	SetSoundChannels	( char flags );
extern	char	GetSoundChannels	( void );
#define	channel_A			0x02
#define	channel_B			0x04
#define	channel_C			0x08


// ear/mic/AY sound logging:
extern	long		*sndlog;			// filled in by Do_Output()
extern	long		*sndlogptr;		// output log write pointer
extern	long		*sndlogend;		// output log end pointer

// AY sound chip:
extern	short	AYregnr;			// selected register
extern	Char	AYreg[16];		// 16 registers/ports of the AY chip

// select AY sound chip register
#define	Select_AY_Register(N)		AYregnr = (N)&0x0f

// set arbitrary AY sound chip data register without selecting it
// note: register number R must be in range !!!
#define	Set_AY_Register(R,N)													\
		{	AYreg[R] = N; 						/* store now value in data register	*/	\
			if (sndlogptr<sndlogend)				/* buffer allocated and not full ?	*/	\
			{	*sndlogptr++ = TOTAL-CYCLES;	/* log exact time of writing		*/	\
				*sndlogptr++ = (R)*256 + (N);		/* log what's been written		*/	\
		}	}

// set selected AY sound chip data register
#define	Write_AY_Register(N)		Set_AY_Register(AYregnr,N)

// read selected AY sound chip data register
#define	Read_AY_Register()			AYreg[AYregnr]
