/*
***	Copyright:	1994-1999 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

    20.Oct.01   revised for CW7Pro and ANSI C compliance									hdusel@bnv-gz.de
*/

#include	<timer.h>

extern	void InitZ80		(int hardware);
extern	void RunZ80		    (void);
extern	void HandleReset	(Boolean);
extern	void InstallTicker	(void);
extern	void RemoveTicker	(void);
extern	void Handle_RST0	(void);

extern	Boolean	z80_running;
extern	long	frames_done;
extern	long	frames;
extern	int		cnt;				// counter for screen refresh
extern	int		hurry_up;

extern	Str63	specciWindowName;

struct c32 { long a,b,c,d,e,f,g,h; };
extern	short	scanline;
extern	Char*	scanpptr;
extern	Char*	scanaptr;

extern	Char		zx128pagectrl;		// last byte sent to ZX 128's paging control port
extern	void ZX128PageCtrl	( Char );		// output byte to zx 128's page control port

extern	long		line_cycle_adjust;

extern	Boolean	trace_mode;		// debugger only

extern	Boolean	use_better_z80;	// use Z80()
extern	Boolean	use_best_z80;		// use Z80_PPC()

extern	Boolean	run_unlimited;		// no speed limit
extern	Boolean	run_exact	;		// exact Specci speed
extern	Boolean	run_highres;		// highres screen update
extern	Boolean	writable_rom;

extern	int		z80_hardware;		// actually emulated hardware
#define	zx16 	1
#define	zx48 	2
#define	zx128	3
#define	zxplus2	4
