/*	Z80 Emulator: Normal instruction handlers

***	Copyright:	1995-1999 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

	based on fMSX; Copyright (C) Marat Fayzullin 1994,1995
	All opcodes covered, no unsupported opcodes!

    20.Oct.01   revised for CW7Pro and ANSI C compliance									hdusel@bnv-gz.de
	20.Oct.01	#define USE_INLINE to replace macros by inline functions (req. for CW7Pro)	hdusel@bnv-gz.de
*/


increment_r;
COUNT_PC;
COUNT_INSTR;

switch(n(&pc))
{

// -------	JUMPING, BRANCHING etc. ------------------------

case JP:		jp: time(10); pc=nn(&pc); loop;
case JP_NZ:		if (!(rf&Z_FLAG)) goto jp; time(10); pc+=2; loop;
case JP_NC:		if (!(rf&C_FLAG)) goto jp; time(10); pc+=2; loop;
case JP_PO:		if (!(rf&P_FLAG)) goto jp; time(10); pc+=2; loop;
case JP_P:		if (!(rf&S_FLAG)) goto jp; time(10); pc+=2; loop;
case JP_Z:		if (  rf&Z_FLAG ) goto jp; time(10); pc+=2; loop;
case JP_C:		if (  rf&C_FLAG ) goto jp; time(10); pc+=2; loop;
case JP_PE:		if (  rf&P_FLAG ) goto jp; time(10); pc+=2; loop;
case JP_M:		if (  rf&S_FLAG ) goto jp; time(10); pc+=2; loop;

case JR:						{ pc+=dis(&pc); time(12); loop; }
case JR_NZ:		if(rf&Z_FLAG)	{ pc++;    time(7);  loop; } 
								{ pc+=dis(&pc); time(12); loop; }
case JR_NC:		if(rf&C_FLAG)	{ pc++;    time(7);  loop; } 
							 	{ pc+=dis(&pc); time(12); loop; }
case JR_Z:		if(rf&Z_FLAG)	{ pc+=dis(&pc); time(12); loop; }
							 	{ pc++;    time(7);  loop; }
case JR_C:		if(rf&C_FLAG)	{ pc+=dis(&pc); time(12); loop; }
								{ pc++;    time(7);  loop; }
case DJNZ:		if(--RB) 	 	{ pc+=dis(&pc); time(13); loop; } 
							 	{ pc++;    time(8);  loop; }

case CALL:		call:			w=nn(&pc); PUSHD(&sp, pc); pc=w; time(17); loop;
case CALL_NZ:	if (!(rf&Z_FLAG)) goto call;	pc+=2; time(10); loop;
case CALL_NC:	if (!(rf&C_FLAG)) goto call;	pc+=2; time(10); loop;
case CALL_PO:	if (!(rf&P_FLAG)) goto call;	pc+=2; time(10); loop;
case CALL_P: 	if (!(rf&S_FLAG)) goto call;	pc+=2; time(10); loop;
case CALL_Z: 	if (  rf&Z_FLAG ) goto call;	pc+=2; time(10); loop;
case CALL_C: 	if (  rf&C_FLAG ) goto call;	pc+=2; time(10); loop;
case CALL_PE:	if (  rf&P_FLAG ) goto call;	pc+=2; time(10); loop;
case CALL_M: 	if (  rf&S_FLAG ) goto call;	pc+=2; time(10); loop;

case RET:		pc=POPD(&sp); time(10); loop;
case RET_NZ:	time(5); if(  rf&Z_FLAG ) loop;	goto ret;
case RET_NC:	time(5); if(  rf&C_FLAG ) loop;	goto ret;
case RET_PO:	time(5); if(  rf&P_FLAG ) loop;	goto ret;
case RET_P:		time(5); if(  rf&S_FLAG ) loop;	goto ret;
case RET_Z:		time(5); if(!(rf&Z_FLAG)) loop;	goto ret;
case RET_C:		time(5); if(!(rf&C_FLAG)) loop;	goto ret;
case RET_PE:	time(5); if(!(rf&P_FLAG)) loop;	goto ret;
case RET_M:		time(5); if(!(rf&S_FLAG)) loop;	ret: pc=POPD(&sp); more(6);  loop;

case RST00:  	info_misc1;time(11); exit(rst0_instr);
case RST08:  	info_misc1;time(11); PUSHD(&sp, pc);pc=0x0008;loop;
case RST10:  	info_misc1;time(11); PUSHD(&sp, pc);pc=0x0010;loop;
case RST18:  	info_misc1;time(11); PUSHD(&sp, pc);pc=0x0018;loop;
case RST20:  	info_misc1;time(11); PUSHD(&sp, pc);pc=0x0020;loop;
case RST28:  	info_misc1;time(11); PUSHD(&sp, pc);pc=0x0028;loop;
case RST30:  	info_misc1;time(11); PUSHD(&sp, pc);pc=0x0030;loop;
case RST38:  	info_misc1;time(11); PUSHD(&sp, pc);pc=0x0038;loop;


// ---- LD R,X --------------------------------------------

case LD_B_B:	time(4); RB=RB;loop;
case LD_C_B:	time(4); RC=RB;loop;
case LD_D_B:	time(4); RD=RB;loop;
case LD_E_B:	time(4); RE=RB;loop;
case LD_H_B:	time(4); RH=RB;loop;
case LD_L_B:	time(4); RL=RB;loop;
case LD_A_B:	time(4); ra=RB;loop;
case LD_X_B:	time(7); POKE(HL,RB);loop;

case LD_B_C:	time(4); RB=RC;loop;
case LD_C_C:	time(4); RC=RC;loop;
case LD_D_C:	time(4); RD=RC;loop;
case LD_E_C:	time(4); RE=RC;loop;
case LD_H_C:	time(4); RH=RC;loop;
case LD_L_C:	time(4); RL=RC;loop;
case LD_A_C:	time(4); ra=RC;loop;
case LD_X_C:	time(7); POKE(HL,RC);loop;

case LD_B_D:	time(4); RB=RD;loop;
case LD_C_D:	time(4); RC=RD;loop;
case LD_D_D:	time(4); RD=RD;loop;
case LD_E_D:	time(4); RE=RD;loop;
case LD_H_D:	time(4); RH=RD;loop;
case LD_L_D:	time(4); RL=RD;loop;
case LD_A_D:	time(4); ra=RD;loop;
case LD_X_D:	time(7); POKE(HL,RD);loop;

case LD_B_E:	time(4); RB=RE;loop;
case LD_C_E:	time(4); RC=RE;loop;
case LD_D_E:	time(4); RD=RE;loop;
case LD_E_E:	time(4); RE=RE;loop;
case LD_H_E:	time(4); RH=RE;loop;
case LD_L_E:	time(4); RL=RE;loop;
case LD_A_E:	time(4); ra=RE;loop;
case LD_X_E:	time(7); POKE(HL,RE);loop;

case LD_B_H:	time(4); RB=RH;loop;
case LD_C_H:	time(4); RC=RH;loop;
case LD_D_H:	time(4); RD=RH;loop;
case LD_E_H:	time(4); RE=RH;loop;
case LD_H_H:	time(4); RH=RH;loop;
case LD_L_H:	time(4); RL=RH;loop;
case LD_A_H:	time(4); ra=RH;loop;
case LD_X_H:	time(7); POKE(HL,RH);loop;

case LD_B_L:	time(4); RB=RL;loop;
case LD_C_L:	time(4); RC=RL;loop;
case LD_D_L:	time(4); RD=RL;loop;
case LD_E_L:	time(4); RE=RL;loop;
case LD_H_L:	time(4); RH=RL;loop;
case LD_L_L:	time(4); RL=RL;loop;
case LD_A_L:	time(4); ra=RL;loop;
case LD_X_L:	time(7); POKE(HL,RL);loop;

case LD_B_A:	time(4); RB=ra;loop;
case LD_C_A:	time(4); RC=ra;loop;
case LD_D_A:	time(4); RD=ra;loop;
case LD_E_A:	time(4); RE=ra;loop;
case LD_H_A:	time(4); RH=ra;loop;
case LD_L_A:	time(4); RL=ra;loop;
case LD_A_A:	time(4); ra=ra;loop;
case LD_X_A:	time(7); POKE(HL,ra);loop;

case LD_B_X:	time(7); RB=PEEK(HL);	loop;
case LD_C_X:	time(7); RC=PEEK(HL);	loop;
case LD_D_X:	time(7); RD=PEEK(HL);	loop;
case LD_E_X:	time(7); RE=PEEK(HL);	loop;
case LD_H_X:	time(4); RH=PEEK(HL);	loop;
case LD_L_X:	time(4); RL=PEEK(HL);	loop;
case LD_A_X:	time(7); ra=PEEK(HL);	loop;

case LD_B_N:	time(7); RB=n(&pc);	loop;
case LD_C_N:	time(7); RC=n(&pc);	loop;
case LD_D_N:	time(7); RD=n(&pc);	loop;
case LD_E_N:	time(7); RE=n(&pc);	loop;
case LD_H_N:	time(4); RH=n(&pc);	loop;
case LD_L_N:	time(4); RL=n(&pc);	loop;
case LD_A_N:	time(7); ra=n(&pc);	loop;
case LD_X_N:	time(10);c=n(&pc); POKE(HL,c);	loop;

case LD_xNN_A:	time(13);w=nn(&pc);POKE(w,ra);	loop;
case LD_xBC_A:	time(7); POKE(BC,ra);		loop;
case LD_xDE_A:	time(7); POKE(DE,ra);		loop;
case LD_A_xBC:	time(7); ra = PEEK(BC);		loop;
case LD_A_xDE:	time(7); ra = PEEK(DE);		loop;
case LD_A_xNN:	time(13);w=nn(&pc);ra=PEEK(w);	loop;


// -------	ARITHMETIC + BOOLEAN OPERATIONS ------------------------

case ADD_B:	time(4); M_ADD(&ra, &rf, RB);loop;
case ADD_C:	time(4); M_ADD(&ra, &rf, RC);loop;
case ADD_D:	time(4); M_ADD(&ra, &rf, RD);loop;
case ADD_E:	time(4); M_ADD(&ra, &rf, RE);loop;
case ADD_H:	time(4); M_ADD(&ra, &rf, RH);loop;
case ADD_L:	time(4); M_ADD(&ra, &rf, RL);loop;
case ADD_A:	time(4); M_ADD(&ra, &rf, ra);loop;
case ADD_X:	time(7); c=PEEK(HL);M_ADD(&ra, &rf, c);loop;
case ADD_N:	time(7); c=n(&pc);       M_ADD(&ra, &rf, c);loop;

case SUB_B: time(4); M_SUB(&ra, &rf, RB);loop;
case SUB_C: time(4); M_SUB(&ra, &rf, RC);loop;
case SUB_D: time(4); M_SUB(&ra, &rf, RD);loop;
case SUB_E: time(4); M_SUB(&ra, &rf, RE);loop;
case SUB_H: time(4); M_SUB(&ra, &rf, RH);loop;
case SUB_L: time(4); M_SUB(&ra, &rf, RL);loop;
case SUB_A: time(4); M_SUB(&ra, &rf, ra);loop;	// ra=0;rf=N_FLAG|Z_FLAG;loop;
case SUB_X: time(7); c=PEEK(HL);M_SUB(&ra, &rf, c);loop;
case SUB_N: time(7); c=n(&pc);       M_SUB(&ra, &rf, c);loop;

case ADC_B:	time(4); M_ADC(&ra, &rf, RB);loop;
case ADC_C:	time(4); M_ADC(&ra, &rf, RC);loop;
case ADC_D:	time(4); M_ADC(&ra, &rf, RD);loop;
case ADC_E:	time(4); M_ADC(&ra, &rf, RE);loop;
case ADC_H:	time(4); M_ADC(&ra, &rf, RH);loop;
case ADC_L:	time(4); M_ADC(&ra, &rf, RL);loop;
case ADC_A:	time(4); M_ADC(&ra, &rf, ra);loop;
case ADC_X:	time(7); c=PEEK(HL);M_ADC(&ra, &rf, c);loop;
case ADC_N:	time(7); c=n(&pc);       M_ADC(&ra, &rf, c);loop;

case SBC_B:	time(4); M_SBC(&ra, &rf, RB);loop;
case SBC_C:	time(4); M_SBC(&ra, &rf, RC);loop;
case SBC_D:	time(4); M_SBC(&ra, &rf, RD);loop;
case SBC_E:	time(4); M_SBC(&ra, &rf, RE);loop;
case SBC_H:	time(4); M_SBC(&ra, &rf, RH);loop;
case SBC_L:	time(4); M_SBC(&ra, &rf, RL);loop;
case SBC_A:	time(4); M_SBC(&ra, &rf, ra);loop;
case SBC_X:	time(7); c=PEEK(HL);M_SBC(&ra, &rf, c);loop;
case SBC_N:	time(7); c=n(&pc);       M_SBC(&ra, &rf, c);loop;

case CP_B:	time(4); M_CP(&ra, &rf, RB);loop;
case CP_C:	time(4); M_CP(&ra, &rf, RC);loop;
case CP_D:	time(4); M_CP(&ra, &rf, RD);loop;
case CP_E:	time(4); M_CP(&ra, &rf, RE);loop;
case CP_H:	time(4); M_CP(&ra, &rf, RH);loop;
case CP_L:	time(4); M_CP(&ra, &rf, RL);loop;
case CP_A:	time(4); M_CP(&ra, &rf, ra);loop;	// rf=N_FLAG|Z_FLAG;loop;
case CP_X:	time(7); c=PEEK(HL);M_CP(&ra, &rf, c);loop;
case CP_N:	time(7); c=n(&pc);       M_CP(&ra, &rf, c);loop;

case AND_B:	time(4); M_AND(&ra, &rf, RB);loop;
case AND_C:	time(4); M_AND(&ra, &rf, RC);loop;
case AND_D:	time(4); M_AND(&ra, &rf, RD);loop;
case AND_E:	time(4); M_AND(&ra, &rf, RE);loop;
case AND_H:	time(4); M_AND(&ra, &rf, RH);loop;
case AND_L:	time(4); M_AND(&ra, &rf, RL);loop;
case AND_A:	time(4); M_AND(&ra, &rf, ra);loop;
case AND_X:	time(7); M_AND(&ra, &rf, PEEK(HL));loop;
case AND_N:	time(7); M_AND(&ra, &rf, n(&pc)); loop;

case OR_B:	time(4); M_OR(&ra, &rf, RB);loop;
case OR_C:	time(4); M_OR(&ra, &rf, RC);loop;
case OR_D:	time(4); M_OR(&ra, &rf, RD);loop;
case OR_E:	time(4); M_OR(&ra, &rf, RE);loop;
case OR_H:	time(4); M_OR(&ra, &rf, RH);loop;
case OR_L:	time(4); M_OR(&ra, &rf, RL);loop;
case OR_A:	time(4); M_OR(&ra, &rf, ra);loop;
case OR_X:	time(7); M_OR(&ra, &rf, PEEK(HL));loop;
case OR_N:	time(7); M_OR(&ra, &rf, n(&pc)); loop;

case XOR_B:	time(4); M_XOR(&ra, &rf, RB);loop;
case XOR_C:	time(4); M_XOR(&ra, &rf, RC);loop;
case XOR_D:	time(4); M_XOR(&ra, &rf, RD);loop;
case XOR_E:	time(4); M_XOR(&ra, &rf, RE);loop;
case XOR_H:	time(4); M_XOR(&ra, &rf, RH);loop;
case XOR_L:	time(4); M_XOR(&ra, &rf, RL);loop;
case XOR_A:	time(4); M_XOR(&ra, &rf, ra);loop;	// ra=0;rf=P_FLAG|Z_FLAG;loop;
case XOR_X:	time(7); M_XOR(&ra, &rf, PEEK(HL));loop;
case XOR_N:	time(7); M_XOR(&ra, &rf, n(&pc));loop;

case DEC_B:	time(4); M_DEC(&rf, &RB);loop;
case DEC_C:	time(4); M_DEC(&rf, &RC);loop;
case DEC_D:	time(4); M_DEC(&rf, &RD);loop;
case DEC_E:	time(4); M_DEC(&rf, &RE);loop;
case DEC_H:	time(4); M_DEC(&rf, &RH);loop;
case DEC_L:	time(4); M_DEC(&rf, &RL);loop;
case DEC_A:	time(4); M_DEC(&rf, &ra);loop;
case DEC_X:	time(11);c=PEEK(HL);M_DEC(&rf, &c);POKE(HL,c);loop;

case INC_B:	time(4); M_INC(&rf, &RB);loop;
case INC_C:	time(4); M_INC(&rf, &RC);loop;
case INC_D:	time(4); M_INC(&rf, &RD);loop;
case INC_E:	time(4); M_INC(&rf, &RE);loop;
case INC_H:	time(4); M_INC(&rf, &RH);loop;
case INC_L:	time(4); M_INC(&rf, &RL);loop;
case INC_A:	time(4); M_INC(&rf, &ra);loop;
case INC_X:	time(11);c=PEEK(HL);M_INC(&rf, &c);POKE(HL,c);loop;


/*	RLCA...RRA	set/clr	C
				clear	H=0, N=0
				pres	Z, P, S
*/
case RLCA:	
	time(4); 
  	ra = (ra<<1) + (ra>>7);
  	rf = (rf&~(C_FLAG+N_FLAG+H_FLAG)) + (ra&C_FLAG);
  	loop;
case RRCA:		
	time(4); 
	ra = (ra>>1) + (ra<<7);
	rf = (rf&~(C_FLAG+N_FLAG+H_FLAG)) + (ra>>7);
	loop;
case RLA:
	time(4); 
	c  = ra>>7;
	ra = (ra<<1) + (rf&C_FLAG);
	rf = (rf&~(C_FLAG+N_FLAG+H_FLAG)) + c;
	loop;
case RRA:
	time(4); 
	c  = ra&C_FLAG;
	ra = (ra>>1) + (rf<<7);
	rf = (rf&~(C_FLAG+N_FLAG+H_FLAG)) + c;
	loop;


// ----	WORD OPERATIONS -----------------------------------------

case LD_BC_NN: 	time(10); BC = nn(&pc);	loop;
case LD_DE_NN: 	time(10); DE = nn(&pc);	loop;
case LD_HL_NN: 	time(10); HL = nn(&pc);	loop;
case LD_SP_NN: 	time(10); sp = nn(&pc);	loop;

case LD_xNN_HL:	time(16); w=nn(&pc); POKE(w,RL); POKE(w+1,RH);	loop;
case LD_HL_xNN:	time(16); w=nn(&pc); RL=PEEK(w); RH=PEEK(w+1);	loop;

case JP_HL:		time(4);  pc = HL;	loop;
case LD_SP_HL:	time(6);  sp = HL;	loop;

case ADD_HL_BC:		time(11); M_ADDW(&rf, &HL,BC);	loop;
case ADD_HL_DE:		time(11); M_ADDW(&rf, &HL,DE);	loop;
case ADD_HL_HL:		time(11); M_ADDW(&rf, &HL,HL);	loop;
case ADD_HL_SP:		time(11); M_ADDW(&rf, &HL,sp);	loop;

case DEC_BC:		time(6);  BC--;		loop;
case DEC_DE:		time(6);  DE--;		loop;
case DEC_HL:		time(6);  HL--;		loop;
case DEC_SP:		time(6);  sp--;		loop;

case INC_BC:		time(6);  BC++;		loop;
case INC_DE:		time(6);  DE++;		loop;
case INC_HL:		time(6);  HL++;		loop;
case INC_SP:		time(6);  sp++;		loop;

case PUSH_BC:		time(11); PUSH(&sp, RB); PUSH(&sp, RC);	loop;
case PUSH_DE:		time(11); PUSH(&sp, RD); PUSH(&sp, RE);	loop;
case PUSH_HL:		time(11); PUSH(&sp, RH);	PUSH(&sp, RL);	loop;
case PUSH_AF:		time(11); PUSH(&sp, ra); PUSH(&sp, rf);	loop;

case POP_BC:		time(10); RC=POP(&sp); RB=POP(&sp);	loop;
case POP_DE:		time(10); RE=POP(&sp); RD=POP(&sp);	loop;
case POP_HL:		time(10); RL=POP(&sp); RH=POP(&sp);	loop;
case POP_AF:		time(10); rf=POP(&sp); ra=POP(&sp);	loop;

case EX_DE_HL:	
	time(4);
	w=DE;DE=HL;HL=w;
	loop;
case EX_AF_AF:	
	time(4);
	c=ra;ra=RA2;RA2=c; 
	c=rf;rf=RF2;RF2=c; 
	loop;
case EXX:	
	time(4);
	w=BC;BC=BC2;BC2=w; 
	w=DE;DE=DE2;DE2=w;
	w=HL;HL=HL2;HL2=w; 
	loop;
case EX_HL_xSP:	
	time(19);
	w=POPD(&sp); 
	PUSHD(&sp, HL); 
	HL = w; 
	loop;


// ----	ODDS ----------------------------------------------

case SCF: 	time(4); rf|=C_FLAG; rf&=~(N_FLAG+H_FLAG);			loop;
case CCF: 	time(4); rf^=C_FLAG; rf&=~N_FLAG;					loop;
case CPL: 	time(4); ra=~ra; rf|=N_FLAG+H_FLAG;					loop;
case NOP: 	time(4); 											loop;
case DI:  	info_misc1; time(4); IFF1=IFF2=disabled;			loop;
case EI:  	info_misc1; time(4);
			if (WUFF && IFF1==disabled) ccx=cc-4;
			IFF1=IFF2=enabled;									loop;
case HALT:	info_misc1; time(4); exit(halt_instr);

case OUTA:	
	time(11);
	store_cc;
	Do_Output ( ((Short)ra<<8) + n(&pc),ra );	
	loop;
case INA: 	
	time(11);
	store_cc;
	ra = Do_Input ( ((Short)ra<<8) + n(&pc));
	loop;


// ----	DAA --------------------------------------------------------

case DAA:
	info_misc1;
	time(4);
	if (rf&N_FLAG)			// previous instruction was SUB
	{	if (rf&H_FLAG) ra -= 0x06;
		if (rf&C_FLAG) ra -= 0x60;
	}
	else					// previous instruction was ADD
	{	if ((ra&0x0F)>0x09) rf |= H_FLAG;
		if (rf&H_FLAG) 		ra += 0x06;
		if (ra>0x99) 		rf |= C_FLAG;
		if (rf&C_FLAG)		ra += 0x60;
	};

	rf &= C_FLAG+N_FLAG;
	rf |= zlog_flags[ra];
	loop;


// ----	PREFIX COMMANDS ---------------------------------------------

case PFX_IY:	izp = &IY; goto	XY;
case PFX_IX:	izp = &IX;		XY:
#include "CodesXX.c"

case PFX_CB:
#include "CodesCB.c"

case PFX_ED:
#include "CodesED.c"

default:		// this should never happen
	pc-=1;
	exit(nimp_instr);

};
loop;

